

// 5 feel sensors + color sight
// 2 avoidance movements Turn left or right
// value: want ability to move forward (less resistance)
// genetics: want to roam, watch for food
main:
  NumEnvironments = 5 
  gosub Initialization
  for E = 1 to NumEnvironments
    gosub Environment
    gosub Search
    delay 2000
  next
  xyString 330,300,"ALL DONE"
end

Initialization:
  Deg = 10  // turn amount
  Dist = 2 // forward amount
  FoodCnt = 3  // number of food patches created 
  Cnt = 0 // 
  Dim Mem[8]
  for i=0 to 7
    Mem[i]=0    // no movement learned
  next
  //movements
  TurnLeft = 1
  TurnRight = 2
  Sensors=0 // no sensory input
return   

Environment:
  // random obstacles and food
  ClearScr
  FoodCnt = 3
  linewidth 30
  line 150+random(30),170+random(100),200+random(100),350+random(100)
  line 500+random(100),40+random(100),450+random(100),140+random(50)
  line 600+random(100),450+random(100),700+random(100),300+random(50)
  line 300,200,400,130+random(100)
  line 0,450+random(50),200+random(50),600
  line 0,40,50+random(30),0
  line 750,0,800,50
  line 750,600,800,550
  x1=80\y1=50
  x2=400\y2=30
  x3=650\y3=230
  linewidth 1
  Call DrawCircle (x1,y1,green)
  Call DrawCircle (x2,y2,green) 
  Call DrawCircle (x3,y3,green)
  rLocate 200,500 // place robot
  gosub DisplayMem
return

Search:   
  //stepping on
  while FoodCnt  // search till food is gone
    Senses = (rFeel()>>1)&7 // use only front 3 sensors
    if Senses=0 // no obstacles, move forward looking for food
      RepeatCount =0 // to prevent getting stuck
      rForward Dist     
      if rLook(0)=Green // look straight ahead for food
        // food seen, so eat it if it is close
        if rBeacon(Green)<30 // eat food 
          x = rGPSx() // erase the food eaten
          if x<200
             call DrawCircle(x1,y1,white)
             FoodCnt--
          elseif x<550 and x>230      
             call DrawCircle(x2,y2,white)
             FoodCnt--        
          else
             call DrawCircle(x3,y3,white)         
             FoodCnt--
          endif
        endif
      else // food is not seen so look around
        if random(2) // turn to one side or the other  
          rTurn 2 +random(10)
        else
          rTurn -(2+random(10))
        endif
      endif 
    else  // obstacles have been detected 
      // check to see if current situation is in memory
      if Mem[Senses] 
        // some action has been saved 
        // do the saved action (either left or right
        if Mem[Senses] = TurnLeft then rTurn -Deg
        if Mem[Senses] = TurnRight then rTurn Deg
        //See if this action is repeating do an about face
        RepeatCount++
        if RepeatCount=10 then rturn (150+random(60)) // boredom
      else // no memory for this situtation
        // try to find an action that will reduce the obstruction
        // and if found, save it in memory
        Cnt=0
        call CountSensors(Senses,Cnt)// count the triggered sensors
        OldSenses = Senses // remember the offending sensors
        r=random(2)+1   // pick a random action (1 or 2)
        // and perform that action
        if r=TurnLeft then rTurn -45 
        if r=TurnRight then rTurn 45             
        Senses = (rFeel()>>1)&7 // new sensor reading
        NewCnt=0
        call CountSensors(Senses,NewCnt) // count triggered sensors
        // if action r reduced blockage then save action 
        if NewCnt<Cnt then Mem[OldSenses]=r\gosub DisplayMem  
      endif    
    endif
  wend
return

Sub DrawCircle(x,y,col)
   circle x,y,x+30,y+30,col,col
return

sub CountSensors(S, &Cnt)
  // counts the number of 1's in S and returns 
  // total to the variable passed as Cnt
  mask = 1
  for i=1 to 3
    if S&mask then Cnt++
    mask=mask<<1
  next
return

DisplayMem:
  //Display 7 memory contents
  // 0: nothing in memory
  // 1: turn left
  // 2: turn right
  linewidth 2
  Rectangle 400,490,480,597,black,white
  for k=1 to 7
    xyString 410,480+k*14,k
    xyString 460,480+k*14,Mem[k]," "
  next
return




